; ***************************************
; * NASM Classification Console Program *
; ***************************************

; Assemble with: nasmw -f obj -O3 iw32-64_classification-veng.asm
;		-lC_HelloW.lst : generate listing (if you like)
;
; Include file may be put here with
;   -p win32n.inc
; if you choose to use it

; Link with: ALink iw32-64_classification-veng.obj -c -oPE -m+ -subsys console
;   -c+ : enable case sensitive linking
;   -oPE : Windows PE executable
;   -m+ : generate map file (if you like)
;   -subsys console : generate a console program

; Run from a DOS Box -otherwise the console closes immediately
; after displaying the message

; *************
; * EXTERNALS *
; *************
EXTERN ReadConsoleA
IMPORT ReadConsoleA c:\Windows\system32\Kernel32.dll
		;	 hConsoleInput
		;	[in] Handle to the console input buffer. The handle must have GENERIC_READ access.
		;	
		;	 lpBuffer
		;	[out] Pointer to a buffer that receives the data read from the console input buffer.
		;	
		;	 nNumberOfCharsToRead
		;	[in] Specifies the number of TCHARs to read. Because the function can read either Unicode or ANSI characters,
		; the size of the buffer pointed to by the lpBuffer parameter should be 
		;at least nNumberOfCharsToRead * sizeof(TCHAR) bytes.
		;	
		;	 lpNumberOfCharsRead
		;	[out] Pointer to a variable that receives the number of TCHARs actually read.
		;	
		;	 lpReserved
		;	[in] Reserved; must be NULL.

EXTERN GetTickCount
IMPORT GetTickCount c:\Windows\system32\Kernel32.dll

EXTERN GetStdHandle
  ; :DWORD
  ;   STD_INPUT_HANDLE
  ;   STD_OUTPUT_HANDLE
  ;   STD_ERROR_HANDLE
IMPORT GetStdHandle c:\Windows\system32\Kernel32.dll

EXTERN WriteConsoleA
  ; hConsoleOutput : DWORD
  ;   handle of the console screen buffer to write to

  ; lpBuffer : DWORD
  ;   pointer to buffer to write from

  ; nNumberOfCharsToWrite : DWORD

  ; lpNumberOfCharsWritten : DWORD
  ;   pointer to 32-bit variable,
  ;   filled with number of characters written

  ; lpReserved : DWORD
  ;   Reserved. Must be NULL.
IMPORT WriteConsoleA c:\Windows\system32\Kernel32.dll

EXTERN ExitProcess
  ; :DWORD
  ;   uExitCode
IMPORT ExitProcess c:\Windows\system32\kernel32.dll

; ************
; * INCLUDES *
; ************
;%include "F:\Assembleur\nasm\inc\win32n.inc"
;   This is Windows-related include file for NASM
;   by Tamas Kaproncai, available at
;   http://rs1.szif.hu/~tomcat/win32/

; ***********
; * EQUATES *
; ***********

STD_OUTPUT_HANDLE EQU -11 ; This one is in Win32n.inc
                          ; but we avoid the inclusion of such
                          ; a large file, specially because of
                          ; the large listing it would generate
STD_INPUT_HANDLE EQU -10
; ***************
; * DONNEES     *
; ***************

SECTION DATA USE32 CLASS=data
Uni     								dd     1
Zero   								dq     0.0
Un     								dq     1.0
Deux   								dq     2.0
Dix    								dq     10.0 
DixM    							dq     10000.0 
Q_div64  							dq     1000000000000000000.0
Lim_Nb								dq		 965211250482432409.0

Msg_Console 					times 50 db ' '
Lg_Msg_Console 				EQU 50

Ligne  DB    0Ah,0Dh,0
Lg_Ligne EQU $-Ligne

Espace  DB    ' ',0
Lg_Espace EQU $-Espace

Msg_Init1    DB			' This program gives you the decomposition of the prime number you enter : ',0
Lg_Msg_Init1 EQU $-Msg_Init1

Msg_Init2    DB			' Prime = Weight * Level + Gap',0
Lg_Msg_Init2 EQU $-Msg_Init2

Msg_Init3    DB			' Tested up to 948895995818594437 in 4622 sec.',0
Lg_Msg_Init3 EQU $-Msg_Init3

Msg_Init3a    DB		' Fabien Sibenaler 2006 - 2007',0
Lg_Msg_Init3a EQU $-Msg_Init3a

Msg_Init4    DB			' ( CTRL-C to exit )',0
Lg_Msg_Init4 EQU $-Msg_Init4

Msg_Accueil  DB			'Enter a prime number   11 <= p < 965,211,250,482,432,384  : ',0
Lg_Msg_Accueil EQU $-Msg_Accueil

Msg_Cramer  DB    	'Limite de Cramer :',0
Lg_Msg_Cramer EQU $-Msg_Cramer

Msg_Nombre  DB    	'Number     :',0
Lg_Msg_Nombre EQU $-Msg_Nombre

Msg_Nombre_pn1  DB  'Number sup :',0
Lg_Msg_Nombre_pn1 EQU $-Msg_Nombre_pn1

Msg_Max  DB    			'Number too high !!!',0
Lg_Msg_Max EQU $-Msg_Max

Msg_Calcul  DB    	'Running ...',0
Lg_Msg_Calcul EQU $-Msg_Calcul

Msg_Temps  DB    		'Time in ms :',0
Lg_Msg_Temps EQU $-Msg_Temps

Msg_Saut  DB    		'Gap        :',0
Lg_Msg_Saut EQU $-Msg_Saut

Msg_L    DB    		'L          :',0
Lg_Msg_L EQU $-Msg_L

Msg_Poids  DB    		'Weight     :',0
Lg_Msg_Poids EQU $-Msg_Poids

Msg_Niveau  DB    	'Level      :',0
Lg_Msg_Niveau EQU $-Msg_Niveau

Msg_Nonnum  DB    	'!!! This is not a number !!!',0
Lg_Msg_Nonnum EQU $-Msg_Nonnum

Msg_Nonpre  DB    	'!!! This number is not prime !!!',0
Lg_Msg_Nonpre EQU $-Msg_Nonpre

Lg_Msg_Out EQU 20
Max EQU  2145390523


; ----------------------------------

SECTION DATA? USE32 CLASS=BSS
tabpre 								resd 	50000000 
; limite p(50 000 000)^2 =  (982451653)^2 = 965 211 250 482 432 409
qdividende						resq  1
qpuiss    						resq  1
qword_alim            resq  1 
zeroq									resq  1
rec_poids							resq  1
nb_a_teste						resq  1
qdiv									resq  1
nombre_cons  					resq  1
nb_Cram   						resq  1
accu_qw   						resq 	1
mult   								resq  1
reste  								resq  1
accu_dw   						resd 	1
multd  								resd  1
NumberOfCharsRead     resd 	1	
NumberOfCharsWritten 	resd 	1
V_Eax                	resd 	1
lim   								resd 	1
lim_pn1								resd 	1
pos   								resd 	1
nbpre 								resq	1
tempsi 								resd  1
tempsf 								resd  1
saut    							resq  1
p_n   								resq  1 
p_n1   								resq  1 
l   									resq  1
dif_saut							resd  1
poids   							resd  1
niveau   							resq  1
nb_chiffres  					resd  1
nombre_lim  					resd  1
top_p  								resd  1
test_num   						resd  1
lim_Cram   						resd  1
lg_tabpre							resd 	1
max 									resd 	1
Msg_Out  							resb 	10 
fcw16									resw  1
fcw16_save						resw  1


; -----------------------------------
; ***************
; * 	 CODE     *
; ***************

SECTION CODE USE32 CLASS=CODE
..start:
;------------------------- Macros -------------------------------------
%macro Write_Msg 2
	pushad	
  push DWORD STD_OUTPUT_HANDLE
  CALL [GetStdHandle]    ; -> EAX = handle of the
                         ; active screen buffer

  PUSH DWORD 0
  PUSH DWORD NumberOfCharsWritten
  PUSH DWORD %1
  PUSH DWORD %2
  PUSH EAX
  CALL [WriteConsoleA]
	popad
%endmacro

;------------------------Message d'accueil  ------------------------------
	Write_Msg 	Lg_Ligne, Ligne
	Write_Msg 	Lg_Msg_Init1, Msg_Init1
	Write_Msg 	Lg_Ligne, Ligne
	Write_Msg 	Lg_Msg_Init2, Msg_Init2
	Write_Msg 	Lg_Ligne, Ligne
	Write_Msg 	Lg_Msg_Init3, Msg_Init3
	Write_Msg 	Lg_Ligne, Ligne
	Write_Msg 	Lg_Msg_Init3a, Msg_Init3a
	Write_Msg 	Lg_Ligne, Ligne
	Write_Msg 	Lg_Msg_Init4, Msg_Init4
	Write_Msg 	Lg_Ligne, Ligne
debut_pgm:	
	Write_Msg 	Lg_Ligne, Ligne
	Write_Msg 	Lg_Msg_Accueil, Msg_Accueil
	Write_Msg 	Lg_Ligne, Ligne
	
;------------------------Lecture console ------------------------------	
	pushad	
  PUSH DWORD STD_INPUT_HANDLE
  CALL [GetStdHandle]    ; -> EAX = handle of the
                         ; active screen buffer

  PUSH DWORD 0
  PUSH DWORD NumberOfCharsRead
  PUSH DWORD Lg_Msg_Out
  PUSH DWORD Msg_Out
  PUSH EAX
  CALL [ReadConsoleA]
	popad
	Write_Msg Lg_Ligne, Ligne
	
;---------------------Rcupration nb millisecondes depuis allumage XP------------------------------	
	xor eax, eax
	call [GetTickCount]
	mov [tempsi], eax
	
;------------------------Rcupration nombre caractres lus -------------	
	xor eax, eax
	mov eax, [NumberOfCharsRead]
	dec eax
	dec eax
	mov [nb_chiffres], eax

;---------------------------------Vrification numricit  --------------
	xor edi, edi
	mov ecx, [nb_chiffres]
boucle_num:
	cmp ecx, 0
	je conversion_entier
	dec ecx 
	xor eax, eax
	mov al, [Msg_Out+edi]
	inc edi
	mov bl, 47
	mov dword [test_num], 0
boucle_test:
	inc bl
	cmp bl, 58
	je non_numerique
	cmp al, bl
	jne boucle_test
	mov dword [test_num], 1
	jmp boucle_num
non_numerique:
	Write_Msg Lg_Msg_Nonnum, Msg_Nonnum 
	Write_Msg Lg_Ligne, Ligne
	jmp fin_pgm
	
;------------------------------Conversion en entier qword --------------
conversion_entier:
	mov dword [nombre_cons], 0
	mov dword [nombre_cons+4], 0
	mov dword [mult], 10	
	mov dword [nombre_cons], 0
	xor edi, edi
	mov ecx, [nb_chiffres]
boucle_dec:	
	dec ecx
	cmp ecx, 0
	jz fin_boucle_dec
	xor eax, eax
	mov al, [Msg_Out+edi]
	sub al, 48
	mov dword [accu_qw], 0
	mov dword [accu_qw+4], 0
	mov [accu_qw], al
	push ecx
boucle_puiss:
	finit
	fild qword [accu_qw]
	fild qword [mult]
	fmul st1
	fistp qword [accu_qw]
	dec ecx
	cmp ecx, 0
	jnz boucle_puiss
	pop ecx
	fild qword [accu_qw]
	fild qword [nombre_cons]
	fadd st0, st1
	fistp qword [nombre_cons]
	inc edi
	jmp boucle_dec
	
fin_boucle_dec:	
	xor eax, eax
	mov al, [Msg_Out+edi]
	sub al, 48
	add [nombre_cons], eax
			
;---------------------------------------- valeur max  ---------------------	
	finit
  fild qword [nombre_cons]
  fld qword [Lim_Nb]
  fcomi st0, st1
  jbe nb_suplim			
	jmp calcul_borne
	
nb_suplim:
	Write_Msg Lg_Msg_Max, Msg_Max 
	Write_Msg Lg_Ligne, Ligne
	jmp fin_pgm
	

;--------------- calcul de la borne suprieure de p(n+1) conjecture de Cramer  ---------------------
calcul_borne:	
	finit
	FLDLN2                     	; chargement de base-e log of 2 = ln(2)-> y 
	fild qword [nombre_cons]   	; x
	fyl2x												; ln(2) * log2(x) -> ln(x)
	fmul st0										; ln(x)^2									
	fld qword [Un]
	fadd st0, st1
	fild qword [nombre_cons]
	fadd st0, st1
	fistp qword [nb_Cram]
		
;--------------- calcul de la limite du test de primalite sur la borne de Cramer  : ent(racine(sup(p(n+1))) + 1 ---------------------
; 
	finit
	fild qword [nb_Cram] 
	fsqrt
	fld qword [Un]
	fadd st0, st1 
	fistp qword [lim_Cram]
	  
;--------------------- calcul des nombres premiers jusqu' la limite de Cramer et primalit de nombre console --------	
				Write_Msg Lg_Msg_Calcul, Msg_Calcul 
				Write_Msg Lg_Ligne, Ligne
				Write_Msg 	Lg_Ligne, Ligne
	mov dword [zeroq], 0
	mov dword [zeroq], 0
	mov dword [qdiv], 2
	mov dword [qdiv+4], 0
	finit
	
	fild qword [qdiv]
	fild qword [nombre_cons] 
	fprem1 
	fistp qword [reste]
	mov eax, [reste]
	cmp dword eax, 0
	je nombre_cons_compose

	mov dword [zeroq], 0
	mov dword [zeroq], 0
	mov dword [qdiv], 3
	mov dword [qdiv+4], 0
	finit	
	fild qword [qdiv]
	fild qword [nombre_cons] 
	fprem1 
	fistp qword [reste]
	mov eax, [reste]
	cmp dword eax, 0
	je nombre_cons_compose
	
	pushad
	mov dword [top_p], 0
	mov dword [tabpre],2
	mov dword [tabpre+4],3
	mov dword eax, 4 
	mov edi, 1
boucle_princ_nbpre:
	inc eax
	cmp eax , [lim_Cram]
	je fin_calcul_p
	call CALCUL_LIM	
	mov ebx, 2	
	mov esi, 0
;------------------------------------ divisions successives de eax : les nombres premiers sont en dword --------	
boucle_nbpre:
	push eax
	xor edx, edx
	div ebx
	pop eax
	sub edx, 0
	jz non_premier
	cmp ebx, [lim]
	jge  nb_premier
	inc esi
	mov ebx, [tabpre+4*esi]
	jmp boucle_nbpre
nb_premier:
	inc edi
	mov [tabpre+4*edi],eax
	mov dword [qdiv], 0
	mov dword [qdiv+4], 0
	mov dword [qdiv], eax
	finit	
	fild qword [qdiv]
	fild qword [nombre_cons] 
	fprem
	fistp qword [reste]
	push eax
	mov eax, [reste]
	cmp dword eax, 0
	je nombre_cons_compose
	pop eax
	jmp boucle_princ_nbpre
non_premier:
	jmp boucle_princ_nbpre
	
nombre_cons_compose:
	Write_Msg Lg_Msg_Nonpre, Msg_Nonpre 
	Write_Msg Lg_Ligne, Ligne
	jmp fin_pgm
	
fin_calcul_p:	
	mov eax, [tabpre+4*edi]
	
	
;------------------------------------calcul du p(n+1) ------------------------------	
	finit
	fild qword [nombre_cons]   	; x	
	fistp qword [nb_a_teste]
boucle_princ_pn1:
	finit
	fild qword [nb_a_teste]   	; x	
	fld qword [Un]
	fadd st0, st1
	fistp qword [nb_a_teste]
	call CALCUL_LIM_Q
						
	mov ebx, 2	
	mov esi, 0
	
;--------------------- divisions successives de eax --------	
boucle_pn1:
	mov dword [qdiv], 0
	mov dword [qdiv+4], 0
	mov dword [qdiv], ebx
	finit	
	fild qword [qdiv]
	fild qword [nb_a_teste] 
	fprem
	fistp qword [reste]
	mov eax, [reste]
	cmp dword eax, 0
	je pn1_non_premier
		
	cmp ebx, [lim_pn1]
	jge  pn1_premier
	inc esi
	cmp esi, edi
	jg pn1_premier
	mov ebx, [tabpre+4*esi]
	jmp boucle_pn1
pn1_premier:
	finit
	fild qword [nb_a_teste]   	; x	
	fistp qword [p_n1]
	mov eax, [p_n1]
	jmp classification
pn1_non_premier:
	jmp boucle_princ_pn1
	
;-----------------------------------classification du p(n) ------------------------------		
classification:	
	
	finit
	fild qword [nombre_cons]   	
	fistp qword [p_n]
	finit
	fild qword [nb_a_teste]   	; x	
	fistp qword [p_n1]
				Write_Msg 	Lg_Msg_Nombre, Msg_Nombre
				finit
				fild qword [p_n]
				fistp qword [qword_alim]
				call Alim_Msg_Console_Qword
				Write_Msg Lg_Msg_Console, Msg_Console
				Write_Msg Lg_Ligne, Ligne
				Write_Msg Lg_Ligne, Ligne
;---------------------saut ------------------------------			
	
	mov eax, [p_n1]
	finit
	fild qword [p_n] 
	fild qword [p_n1]
	fsub st0, st1  	
	fistp qword [saut]
				Write_Msg Lg_Msg_Saut, Msg_Saut 
				finit
				fild qword [saut]
				fistp qword [qword_alim]
				call Alim_Msg_Console_Qword
				Write_Msg Lg_Msg_Console, Msg_Console
				Write_Msg Lg_Ligne, Ligne
				Write_Msg Lg_Ligne, Ligne
	
;---------------------calcul de l ------------------------	
	finit
	fild qword [p_n] 
	fld qword [Deux]
	fmul st0, st1  
	fistp qword [l]
	
	finit	
	fild qword [p_n1]
	fild qword [l]
	fsub st0, st1
	fistp qword [l]
	
	finit
	fild qword [saut]
	fild qword [l]
	fcomi st0, st1	
	jg l_not0
	mov dword [l], 0
	mov dword [l+4], 0
	jmp calcul_poids
l_not0:
	;mov [l], eax
	
;---------------------calcul du poids --------------------
calcul_poids:
	finit
	fild qword [Zero]
	fild qword [l]
	fcomi st0, st1				
	;mov dword eax, [l]
	;cmp eax, 0
	jg poids_not0
	mov dword [poids], 0
	mov dword [poids+4], 0
				Write_Msg Lg_Msg_Poids, Msg_Poids 
				Write_Msg Lg_Msg_Poids, Msg_Poids 
				finit
				fild qword [poids]
				fistp qword [qword_alim]
				call Alim_Msg_Console_Qword
				Write_Msg Lg_Msg_Console, Msg_Console
				Write_Msg Lg_Ligne, Ligne
				Write_Msg Lg_Ligne, Ligne
	jmp calcul_niveau
poids_not0:
	mov dword [poids], 0
	mov dword [poids+4], 0
	
	finit
	fild qword [saut] 
	fld qword [Un]
	fadd st0, st1 
	fistp qword [rec_poids]
boucle_poids:
	finit
	fild qword [Zero]
	fild qword [poids]
	fcomi st0, st1
	;mov dword eax, [poids]
	;cmp eax, 0
	jg fin_boucle_poids
	finit
	fild qword [p_n]
	fild qword [rec_poids]
	fcomi st0, st1
	jle fin_boucle_poids
				
	mov dword [qdiv], 0
	mov dword [qdiv+4], 0
	mov dword [qdiv], ebx
	finit	
	fild qword [rec_poids]
	fild qword [p_n] 
	fprem
	fistp qword [reste]
	mov eax, [reste]
	cmp dword eax, [saut]
	jz poids_trouve
	fild qword [rec_poids] 
	fld qword [Deux]
	fadd st0, st1 
	fistp qword [rec_poids]
	jmp boucle_poids
poids_trouve:
	fild qword [rec_poids]
	fistp qword [poids] 
	jmp boucle_poids
	
fin_boucle_poids:	
				Write_Msg Lg_Msg_Poids, Msg_Poids 
				finit
				fild qword [poids]
				fistp qword [qword_alim]
				call Alim_Msg_Console_Qword
				Write_Msg Lg_Msg_Console, Msg_Console
				Write_Msg Lg_Ligne, Ligne
				Write_Msg Lg_Ligne, Ligne
;---------------------calcul du niveau -------------------------
calcul_niveau:
	;jmp fin_pgm
	mov dword [niveau], 0
	mov dword [niveau+4], 0
	finit
	fild qword [Zero]
	fild qword [poids]
	fcomi st0, st1
	;mov eax,[poids]
	;sub eax, 0
	jz niveau_0
	finit
	fild qword [poids]
	fild qword [l]
	fdiv st0, st1
	fistp qword [niveau]
	;mov eax, [l]
	;mov ebx, [poids]
	;xor edx, edx
	;div ebx
	;mov [niveau], eax
	jmp fin_niveau
niveau_0:
	mov dword [niveau], 0
	mov dword [niveau+4], 0
fin_niveau:
				Write_Msg Lg_Msg_Niveau, Msg_Niveau 
				finit
				fild qword [niveau]
				fistp qword [qword_alim]
				call Alim_Msg_Console_Qword
				Write_Msg Lg_Msg_Console, Msg_Console
				Write_Msg Lg_Ligne, Ligne
				Write_Msg Lg_Ligne, Ligne
;--------------------------------Fin classification du p(n) --------------------------------------	

fin_pgm:
	xor eax, eax
	call [GetTickCount]
	mov [tempsf], eax
	pushad 
	Write_Msg Lg_Ligne, Ligne
	Write_Msg Lg_Msg_Temps, Msg_Temps
	xor eax, eax
	xor ebx, ebx
	mov eax, [tempsf]
	mov ebx, [tempsi]
	sub eax, ebx
	call Alim_Msg_Console_Eax
	Write_Msg Lg_Msg_Console, Msg_Console
	Write_Msg Lg_Ligne, Ligne
	popad
	jmp debut_pgm
	
	PUSH DWORD 0           ; exit code
  CALL [ExitProcess]
	
;********************************************************************
;	                       PROCEDURES
;********************************************************************
CALCUL_LIM_Q
	pushad
	finit
	fild qword [nb_a_teste] 
	fsqrt 
	fistp dword [lim_pn1]
	inc dword [lim_pn1]
	popad
	ret
	
CALCUL_LIM
	pushad
	mov [lim],eax 
	finit
	fild dword [lim] 
	fsqrt 
	fist dword [lim]
	inc dword [lim]
	popad
	ret

Alim_Msg_Console_Eax:
		pushad
		
		mov ecx, 49
		mov edi, 0
	init:	
		mov word [Msg_Console + edi], ' '
		inc edi
		loop init
		
		mov edi, 0
		mov ebx, 3B9ACA00h ;1000000000 en dec
		xor cl, cl
	boucle3:
		xor edx, edx
		div ebx
		;test pour ne pas afficher les zros de devant
		or cl, al
		cmp cl, 0
		je nepasafficherzero3
		push eax
		add al, 30h ;48 en dec
		mov ah, 0Eh
		mov [Msg_Console + edi], ax
		inc edi
		;int 10h
		pop eax
	nepasafficherzero3:
		cmp bl, 1
		je finboucle3
		push eax
		push edx
		xor edx, edx
		mov eax, ebx
		mov ebx, 0000000Ah ;pour diviser par 10 soit 000A
		div ebx
		mov ebx, eax
		pop eax ;je rcupre edx dans eax et eax dans edx
		pop edx
		
		jmp boucle3
	finboucle3:
		cmp cl, 0
		jne fin3
		mov al, 30h
		mov [Msg_Console + edi], al
		jmp fin_alim
		;int 10h
	fin3:
		;mov ax, ligne
		;cmp word [Msg_Console + edi], 0E30h
		;je fin_alim
		mov word [Msg_Console + edi], ' '
	fin_alim:
		popad
		ret
;----------------------------------------------------------------------------------
Alim_Msg_Console_Qword:
		pushad
		mov ecx, 49
		mov edi, 0
	init_q:	
		mov word [Msg_Console + edi], ' '
		inc edi
		loop init_q
		
		mov edi, 0
		finit
		fld qword [Q_div64]
		fistp qword [qpuiss]
		xor cl, cl
	boucle3_q:
		finit
		fstcw [fcw16]
		mov   ax, [fcw16]
		mov   [fcw16_save], ax
		and   ax, 0f0ffh
		or    ax, 00c00h
		mov   [fcw16], ax
		 
		fldcw  [fcw16]
		fild qword [qpuiss]
		fild qword [qword_alim]
		fdiv st0, st1
		FRNDINT
		fistp qword [qdividende]
		fldcw  [fcw16_save]
		xor eax, eax
		mov word ax, [qdividende]		
		or cl, al
		cmp cl, 0
		je nepasafficherzero3_q
		push eax
		mov word ax, [qdividende]
		add al, 30h ;48 en dec
		mov ah, 0Eh
		mov [Msg_Console + edi], ax	
		inc edi
		pop eax
				
	nepasafficherzero3_q:
		cmp dword [qpuiss], 1
		je finboucle3_q
		finit
		fild qword [qpuiss]
		fild qword [qword_alim]
		fprem
		fistp qword [qword_alim]
				
		finit
		fld qword [Dix]
		fild qword [qpuiss]
		fdiv st0, st1
		fistp qword [qpuiss]
		jmp boucle3_q
	finboucle3_q:
		cmp cl, 0
		jne fin3_q
		mov al, 30h
		mov [Msg_Console + edi], al
		jmp fin_alim_q
	fin3_q:
		mov word [Msg_Console + edi], ' '
	fin_alim_q:
		popad
		ret